import configparser
import os
import sys
import time

import requests
from datetime import datetime
sys.path.append(os.getcwd())

from common import Feishu, AliyunLogger, Common

config = configparser.ConfigParser()
config.read('./config.ini')

class messageData():
    @classmethod
    def create_folders(cls, name):
        v_text_url = config['PATHS']['TXT_PATH']
        if not os.path.exists(v_text_url):
            os.makedirs(v_text_url)
        text_path = v_text_url + f"{name}.text"
        try:
            #  尝试打开文件进行读取
            with open(text_path, 'r') as file:
                # 读取第一行内容
                first_data = file.readline().strip()
                # 判断第一行是否为空
                if not first_data:
                    return None, text_path
                else:
                    return first_data, text_path
        except FileNotFoundError:
            with open(text_path, 'w') as file:
                print("文件不存在，已创建新文件:", text_path)
                return None, text_path


    @classmethod
    def wx_data(cls, data_list):
        name = data_list['name']
        cookie = data_list['cookie']
        first_data, text_path = cls.create_folders(name)
        url = "https://mp.weixin.qq.com/wxopen/wasysnotify?action=get&msg_type=1&lang=zh_CN&f=json&ajax=1&begin=0&count=50"
        payload = {}
        headers = {
            'accept': 'application/json, text/javascript, */*; q=0.01',
            'accept-language': 'zh-CN,zh;q=0.9',
            'cache-control': 'no-cache',
            'cookie': cookie,
            'pragma': 'no-cache',
            'sec-fetch-dest': 'empty',
            'sec-fetch-mode': 'cors',
            'sec-fetch-site': 'same-origin',
            'x-requested-with': 'XMLHttpRequest'
        }
        response = requests.request("GET", url, headers=headers, data=payload)
        data = response.json()
        err_msg = data["base_resp"]["err_msg"]
        if err_msg == "ok":
            item_list = data["notify_msg_item_list"]["item"]
            try:
                for itme in item_list:
                    id = itme["id"]
                    contents = [
                        (f"aggregate_id", str(itme["aggregate_id"])),
                        (f"aggregate_num", str(itme["aggregate_num"])),
                        (f"aggregate_type", str(itme["aggregate_type"])),
                        (f"client_msg_id", str(itme["client_msg_id"])),
                        (f"content", str(itme["content"]).replace("\r", " ").replace("\n", " ")),
                        (f"create_time", str(itme["create_time"])),
                        (f"id", str(id)),
                        (f"module", str(itme["module"])),
                        (f"msg_status", str(itme["msg_status"])),
                        (f"msg_type", str(itme["msg_type"])),
                        (f"notify_tmpl_id", str(itme["notify_tmpl_id"])),
                        (f"openid_list", str(itme["openid_list"])),
                        (f"process_status", str(itme["process_status"])),
                        (f"title", str(itme["title"]).replace("\r", " ").replace("\n", " ")),
                        (f"update_time", str(itme["update_time"])),
                        (f"url", str(itme["url"])),
                        (f"channel", name),
                        ("timestamp", str(int(time.time()))),
                    ]
                    if first_data:
                        if first_data == str(id):
                            with open(text_path, 'w') as f:
                                f.write(f"{item_list[0]['id']}")
                            return
                        AliyunLogger.logging(contents)
                    else:
                        update_time = itme["update_time"]
                        # 获取当前日期和时间
                        current_datetime = datetime.now()
                        now_date = current_datetime.strftime("%Y-%m-%d")
                        # 将时间戳转换为日期时间
                        date_time = datetime.fromtimestamp(update_time)
                        # 将日期时间对象格式化为字符串（"%Y-%m-%d"格式）
                        formatted_date = date_time.strftime("%Y-%m-%d")
                        if now_date == formatted_date:
                            AliyunLogger.logging(contents)
                        else:
                            with open(text_path, 'w') as f:
                                f.write(f"{item_list[0]['id']}")
                            return
                with open(text_path, 'w') as f:
                    f.write(f"{item_list[0]['id']}")
            except Exception as e:
                Common.logger("wx").error(f"抓取异常:{e}\n")
                Feishu.bot('微信公众号后台消息通知,请注意查收', f'抓取异常请关注')
        else:
            Feishu.bot('微信公众号后台消息通知,请注意查收', f'{name}cookie，请及时更换')


if __name__ == '__main__':
    name = "票圈视频"
    Feishu.bot('微信公众号后台消息通知,请注意查收', f'{name}cookie，请及时更换')